
// SyncDirDlg.h: archivo de encabezado
//

#pragma once
#include "afxcmn.h"
#include "ShowPc.h"
#include "ibtabctrl.h"
#include "opcionesdlg.h"
#include "FileManager.h"

/////////////////////////////////////////////////////////////////////////////
// CDirWatcherDlg dialog
#include "DirectoryChanges.h"
#include "afxwin.h"

class CMyDirectoryChangeHandler : public CDirectoryChangeHandler
{
public:
	CMyDirectoryChangeHandler()
		: CDirectoryChangeHandler(){}

	CFileManager file;

protected:
	//These functions are called when the directory to watch has had a change made to it
	void On_FileAdded(const CString & strFileName)
	{
		// agregar a archivo defecto
		CString str = _T("add ")+strFileName;
		//AfxMessageBox(str);
		file.SaveFast(str);
	}
	void On_FileRemoved(const CString & strFileName)
	{
		// agregar a archivo defecto
		CString str = _T("rem ")+strFileName;
		//AfxMessageBox(str);
		file.SaveFast(str);
	}
	void On_FileModified(const CString & strFileName)
	{
		// agregar a archivo defecto
		CString str = _T("mod ")+strFileName;
		//AfxMessageBox(str);
		file.SaveFast(str);

	}
	void On_FileNameChanged(const CString & strOldFileName, const CString & strNewFileName)
	{
		// agregar a archivo defecto
		CString str = _T("ren ")+strOldFileName+_T(" ")+strNewFileName;
		//AfxMessageBox(str);
		file.SaveFast(str);
	}

//	void On_WatchStarted(DWORD dwError, const CString & strDirectoryName)
//	{
//		if( dwError == 0 )
//			m_listBox.AddString( _T("Directory Watch Started: ") + strDirectoryName);
//		else
//			m_listBox.AddString( _T("Directory watch failed: ") + strDirectoryName);
//	}
//	void On_WatchStopped(const CString & strDirectoryName)
//	{
//		//
//		//	NOTE:  Be careful ! On_WatchStopped can be called AFTER this list box has
//		//	been destoroyed.  Be carefull whenever interacting w/ windows with this function
//		//	because the window may not be valid when this function is executed for the last time.
//		//
//		//
//		if( ::IsWindow( m_listBox.GetSafeHwnd() ) )
//			m_listBox.AddString(_T("Stopped watching directory: ") + strDirectoryName);
//		else
//		{
//			TRACE(_T("NOTE: m_listBox is not a valid window! This has probably been called as the result of program shutdown sometime after CDirWatcherDlg::OnBtnMonitor2() was used to watch a direcotry.\n"));
//			TRACE(_T("NOTE: Be sure that you are careful in your implementation of this function to watch out for the same condition if you are dealing w/ windows.\n"));
////			MessageBeep(static_cast<UINT>(-1));
////			MessageBeep(static_cast<UINT>(-1));
////			MessageBeep(static_cast<UINT>(-1));
//			
//			//
//			//	See the comments in DirectoryChanges.h for the CDirectoryChangeHandler::On_WatchStopped() function.
//			//
//			//
//		}
//	}
};
// CDirWatcherDlg dialog End
//////////////////////////////////////////////////////////////////////////////////


#define MYWM_NOTIFYICON (WM_USER+1)

// Cuadro de dilogo de CSyncDirDlg
class CSyncDirDlg : public CDialogEx
{
// Construccin
public:
	CSyncDirDlg(CWnd* pParent = NULL);	// Constructor estndar

// Datos del cuadro de dilogo
	enum { IDD = IDD_SYNCDIR_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// Compatibilidad con DDX/DDV


// Implementacin
protected:
	HICON m_hIcon;
	// Funciones de asignacin de mensajes generadas
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

public:
	//CFileManager file;
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedOpciones();
	afx_msg void OnBnClickedCancel();
	CString m_sEstado;
	CString m_sDirParent;
	CibTabCtrl m_cTab;
	COpcionesDlg *m_dOpcionesDlg;
	CShowPc *m_tTab[9];
	int m_bInit;
	afx_msg void OnMove(int x, int y);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);

	int m_iPredet;
	int UpdateTab(int n); // Funcin de actualizacin del panel de muestra de estado de las conexiones.
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	virtual int SetCTimer(void); 	// Habilita el timer.
	int KillCTimer(void); // Elimina el Timer.
	// Variables del contador de tiempo general de conexiones.
	int m_iChronotrigger;
	int m_iChronotriggerM;
	int m_iChronotriggerH;
	CString m_sChronotrigger;

	CMenu m_TrayMenu;
	NOTIFYICONDATA tnd;
	afx_msg LRESULT onTrayNotify(WPARAM, LPARAM);


private:
	bool m_bInicio;
	void CSyncDirDlg::IniciaCliente(void);
	void CSyncDirDlg::IniciaServidor(void);
	CWinThread *m_pWinThreadClient;
	CWinThread *m_pWinThreadServer;

protected:
	CDirectoryChangeWatcher			m_DirWatcher;
	CMyDirectoryChangeHandler		m_DirChangeHandler;
	

public:
	CString sEstado;
	static UINT CSyncDirDlg::ThreadClientFunc( LPVOID pParam );
	static UINT CSyncDirDlg::ThreadServerFunc( LPVOID pParam );

	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMenuRestaurar();
	afx_msg void OnMenuSincronizar();
	afx_msg void OnMenuOpciones();
	afx_msg void OnMenuCerrar();
private:
	int m_iBotonConectarDesconectar;
	CButton m_cBotonConectarDesconectar;
};

